<?php

namespace xenarabia\MYMMSMSG\XF\Admin\Controller;

use XF\Mvc\FormAction;
use XF\Mvc\ParameterBag;
use XF\Mvc\Reply\View;
use XF\Admin\Controller\AbstractController;

use xenarabia\MYMMSMSG\XF\Entity\CatMyMms;

class CatMMs extends AbstractController{


    public function actionIndex(ParameterBag $params)
	{
		$page = $this->filterPage($params->page);
		$perPage = 20;
        $catmms = $this->finder('xenarabia\MYMMSMSG\XF:CatMyMms')->limitByPage($page, $perPage);
        
		$viewParams = [
			'catmms'	=> $catmms->fetch(),
            'total' => $catmms->total(),
            'page' => $page,
            'perPage' => $perPage,

		];
		return $this->view('xenarabia\MYMMSMSG\XF:catmms\view', 'catmms_view', $viewParams);
	}


	public function actionView(ParameterBag $params)
	{
		$page = $this->filterPage($params->page);
		$perPage = 20;
        $catmms = $this->finder('xenarabia\MYMMSMSG\XF:CatMyMms')->limitByPage($page, $perPage);
        
		$viewParams = [
			'catmms'	=> $catmms->fetch(),
            'total' => $catmms->total(),
            'page' => $page,
            'perPage' => $perPage,

		];
		return $this->view('xenarabia\MYMMSMSG\XF:catmms\view', 'catmms_view', $viewParams);
	}

	public function actionAdd()
	{
		/** @var xenarabia\MYMMSMSG\XF\Entity\CatMyMms $catmms */
		
		return $this->view('xenarabia\MYMMSMSG\XF:MYMMSMSG\add', 'catmms_add', []);
	}


	/** @var xenarabia\MYMMSMSG\XF\Entity\CatMyMms $catmmsEntity */
	protected function catmmsEdit(CatMyMms $catmmsEntity)
	{
		// $catmms = $this->finder('xenarabia\MYMMSMSG\XF:CatMyMms')->fetchOne();
		$viewParams = [
			'catmms'	=> $catmmsEntity
		];
		return $this->view('xenarabia\MYMMSMSG\XF:MYMMSMSG\add', 'catmms_add', $viewParams);
	}

	public function actionEdit(ParameterBag $params)
	{
		$catmms = $this->assertCatmmsExists($params->cat_id);

		return $this->catmmsEdit($catmms);
	}

	
	public function actionSave(ParameterBag $params)
	{
		$this->assertPostOnly();
		if ($params->cat_id) {
			$catmms = $this->assertCatmmsExists($params->cat_id);
			$form = $this->catmmsEditSave($catmms);
		} else {
			$catmms = $this->em()->create('xenarabia\MYMMSMSG\XF:CatMyMms');
			$form = $this->pageSaveProcess($catmms);
		}

		
		if (get_class($form) === 'XF\Mvc\Reply\Error') {
			return $form;
		} else {
			$form->run();
		}

		return $this->redirect($this->buildLink('catmymms'), \XF::phrase('your_changes_have_been_saved'));
	}

	/** @var xenarabia\MYMMSMSG\XF\Entity\CatMyMms $catmmsEntity */
	protected function catmmsEditSave(CatMyMms $catmmsEntity)
	{
		$entityInput = $this->filter([
									'cat_title' => 'str',
									'cat_act' => 'int'
									]);

		$form = $this->formAction();
		$form->basicEntitySave($catmmsEntity, $entityInput);

		return $form;
	}
	
	

    public function actionToggle(ParameterBag $params)
    {
        /** @var \XF\ControllerPlugin\Toggle $plugin */
        $plugin = $this->plugin('XF:Toggle');
        return $plugin->actionToggle('xenarabia\MYMMSMSG\XF:CatMyMms', 'cat_act');
    }


	/** @var xenarabia\MYMMSMSG\XF\Entity\CatMyMms $catmmsEntity */
	protected function pageSaveProcess(CatMyMms $catmmsEntity)
	{
		$entityInput = $this->filter([
									'cat_title' => 'str',
									'cat_act' => 'int'
									]);

		$form = $this->formAction();
		$form->basicEntitySave($catmmsEntity, $entityInput);

		return $form;
	}


	public function actionDelete(ParameterBag $params)
	{
		$catmms = $this->assertCatmmsExists($params->cat_id);

		$totalMsgs = $this->finder('xenarabia\MYMMSMSG\XF:MmsMsgs')->where('mms_cat_id', $params->cat_id)->total();
		/** @var xenarabia\XF\ControllerPlugin\DeleteCat $plugin */
		$plugin = $this->plugin('xenarabia\MYMMSMSG\XF:DeleteCat');
		
		return $plugin->actionDelete(
			$catmms,
			$this->buildLink('catmymms/delete', $catmms),
			$this->buildLink('catmymms/edit', $catmms),
			$this->buildLink('catmymms/', $catmms),
			$catmms->cat_title, null, [
				'deletionImportantPhrase' => \XF::phrase('mms_all_msgs_under_this_cat_will_be_delete_it', ['msg_no' => $totalMsgs]),
				'total' => $totalMsgs
			]
		);
	}

	public function actionViewMsgs(ParameterBag $params)
	{
		$catId = $params->cat_id;
		$page = $this->filterPage($params->page);
		$perPage = 20;
        $mmsmsgs = $this->finder('xenarabia\MYMMSMSG\XF:MmsMsgs')
		->where('mms_cat_id', $catId)
		->with('CatMyMms')->limitByPage($page, $perPage);
		$catName = $this->finder('xenarabia\MYMMSMSG\XF:CatMyMms')->where('cat_id', $catId)->fetchOne();
		$catmms = $this->finder('xenarabia\MYMMSMSG\XF:CatMyMms')->where('cat_id', $catId)
		->where('cat_id', $catId)->limitByPage($page, $perPage)
		->with('MmsMsgs');
		
		$viewParams = [
			'mmsmsgs'	=> $catmms->fetchRaw(),
            'total' => $mmsmsgs->total(),
            'page' => $page,
            'perPage' => $perPage,
			'catName' => $catName->cat_title
			
		];
		// \XF::dump($catName->cat_title);
		return $this->view('xenarabia\MYMMSMSG\XF:mmsmsg\view', 'mmsmsgs_by_cat_list', $viewParams);
	}


	protected function assertCatmmsExists($id, $with = null, $phraseKey = null)
	{
		return $this->assertRecordExists('xenarabia\MYMMSMSG\XF:CatMyMms', $id, $with, $phraseKey);
	}

}